/* Several helper functions for
 * - Conversion bool -> integer
 * - Calculate odd parity for a byte
 * - Conversion char array -> integer
 */
#include "helpfunctions.h"
#include <math.h>

unsigned int bool2int(bool *array)
{
	unsigned int result = 0;
	for(int i=0;i<8;i++) {
		result += pow(2,i)*array[i];
	}
	return result;
}

bool calculateParityBit(unsigned char input)
{
	bool parityBit = true;
	for(int i=0;i<8;i++) {
		parityBit ^= ((input >> i) & 0x1);
	}
	return parityBit;
}

unsigned int* char2int(char *array, int length)
{
	unsigned int *code = new unsigned int[(length-1)/8 + 1];
	int offset = (8-length % 8) % 8;
	int arrayIndex;
	for(int i=offset;i<length+offset;i++)
	{
		if(i%8 == 0 || i == offset) {
			code[i/8] = 0;
		}
		arrayIndex = i-offset;
		if(array[arrayIndex] == '0') code[i/8] += (0x00<<4*(7-i%8));
		if(array[arrayIndex] == '1') code[i/8] += (0x01<<4*(7-i%8));
		if(array[arrayIndex] == '2') code[i/8] += (0x02<<4*(7-i%8));
		if(array[arrayIndex] == '3') code[i/8] += (0x03<<4*(7-i%8));
		if(array[arrayIndex] == '4') code[i/8] += (0x04<<4*(7-i%8));
		if(array[arrayIndex] == '5') code[i/8] += (0x05<<4*(7-i%8));
		if(array[arrayIndex] == '6') code[i/8] += (0x06<<4*(7-i%8));
		if(array[arrayIndex] == '7') code[i/8] += (0x07<<4*(7-i%8));
		if(array[arrayIndex] == '8') code[i/8] += (0x08<<4*(7-i%8));
		if(array[arrayIndex] == '9') code[i/8] += (0x09<<4*(7-i%8));
		if(array[arrayIndex] == 'a') code[i/8] += (0x0a<<4*(7-i%8));
		if(array[arrayIndex] == 'b') code[i/8] += (0x0b<<4*(7-i%8));
		if(array[arrayIndex] == 'c') code[i/8] += (0x0c<<4*(7-i%8));
		if(array[arrayIndex] == 'd') code[i/8] += (0x0d<<4*(7-i%8));
		if(array[arrayIndex] == 'e') code[i/8] += (0x0e<<4*(7-i%8));
		if(array[arrayIndex] == 'f') code[i/8] += (0x0f<<4*(7-i%8));
	}
	return code;
}

unsigned int* char2int(unsigned char *array, int length)
{
	return char2int((char *)array,length);
}