#ifndef LFSR_H
#define LFSR_H

#include "uint48.h"

class LFSR
{
	private:
		uint48 currentState;
		bool L(uint48 input);
		bool f(uint48 input);
		bool fa(bool input[4]);
		bool fb(bool input[4]);
		bool fc(bool input[5]);
		
	public:
		LFSR();
		~LFSR();
		void initialize(uint48 input);
		void rollback(uint48 input);
		void rollbackNRdecrypted(uint48 input, unsigned int readerChallenge, int ticks);
		void rollbackNRencrypted(uint48 input, unsigned int readerChallenge, int ticks);
		void rollbackUID(uint48 input, unsigned int uid, unsigned int challenge, int ticks);
		uint48 getState();
		bool getBit(unsigned int index);
		bool getKeystream();
		void stepNext();
		void stepNext(unsigned int uid, unsigned int challenge, int ticks);
		void stepNext(unsigned int readerChallenge, int ticks);
};

#endif // LFSR_H
