#include "lfsr.h"
#include "randomgenerator.h"
#include "tagsector.h"
#include "uint48.h"

#ifndef MIFARETAG_H
#define MIFARETAG_H

class MifareTag
{
	private:
		LFSR *mLFSR;
		RandomGenerator *mRandomGenerator;
		TagSector *sectors;
		unsigned int sectorCount;
		unsigned int ticks;
		unsigned int uid;
		unsigned int challenge;
		unsigned int readerChallenge;
		unsigned int readerAnswer;
		
	public:
		MifareTag();
		MifareTag(unsigned int _sectorCount);
		~MifareTag();
		
		
		void tick();
		void resetTag();
		unsigned int getTicks();
		unsigned int getUID();
		unsigned int getChallenge(unsigned int sectorIndex);
		unsigned int answerChallenge(unsigned int _readerChallenge,
									unsigned int _readerAnswer,
									unsigned int parityBits);
		uint48 getLFSRState();
		unsigned int getRandomGeneratorLFSRState();
		unsigned int getRandomGeneratorNonceState();
		bool getKeystream();
		uint48 recoverKeyFromState(uint48 LFSRstate);

};

#endif // MIFARETAG_H
