#include "randomgenerator.h"
#include <cstdlib>

using namespace std;

RandomGenerator::RandomGenerator()
{
	currentNonceState = rand();
	currentLFSRState = rand() % 0x00010000;
}

RandomGenerator::~RandomGenerator()
{
}

/* The feedback function */
bool RandomGenerator::L(unsigned int input)
{
	bool result = (input^(input >> 2)^(input >> 3)^(input >> 5)) & 1;
	return result;
}

/* Output a 32 bit challenge */
unsigned int RandomGenerator::suc(unsigned int input)
{
	unsigned int sequence;
	unsigned int Linput;
	Linput = input >> 16;
	sequence = (input >> 1) | (L(Linput) << 31);
	currentNonceState = sequence;
	return currentNonceState;
}

unsigned int RandomGenerator::calculateSuc(unsigned int input)
{
	suc(currentNonceState);
	return currentNonceState;
}

/* Advance state */
void RandomGenerator::stepNext()
{
	suc(currentNonceState);
	currentLFSRState >>= 1;
	currentLFSRState |= (L(currentLFSRState) << 15);
}

unsigned int RandomGenerator::getLFSRState()
{
	return currentLFSRState;
}
unsigned int RandomGenerator::getNonceState()
{
	return currentNonceState;
}


