#ifndef UINT48_H
#define UINT48_H

class uint48
{
private:
	unsigned int high, low;
public:
	uint48();
	uint48(unsigned int _high, unsigned int _low);
	~uint48();
	uint48 operator<<(int shift);
	uint48 operator>>(int shift);
	uint48 operator&(const uint48 &right);
	uint48 operator|(const uint48 &right);
	uint48 operator^(const uint48 &right);
	uint48 operator&(const unsigned int right);
	uint48 operator|(const unsigned int right);
	uint48 operator^(const unsigned int right);
	uint48 operator~();
	uint48 operator=(const uint48 &other);
	uint48 operator=(const unsigned int other);
	uint48 operator++(const int notused);
	
	const unsigned int getHighInt();
	const unsigned int getLowInt();
	void setHighInt(unsigned int _high);
	void setLowInt(unsigned int _low);
	bool getBit(unsigned int position);
	void setBit(bool bit, unsigned int position);

};

#endif // UINT48_H
